'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-AtomCard';
var CLASS_MEDIA = BASE_CLASS + '-media';
var CLASS_INFO = BASE_CLASS + '-info';

var CLASS_VERTICAL = BASE_CLASS + '--vertical';
var CLASS_HIGHLIGHT = BASE_CLASS + '--highlight';
var CLASS_LINK = BASE_CLASS + '-link';

var AtomCard = function (_Component) {
  (0, _inherits3.default)(AtomCard, _Component);

  function AtomCard() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AtomCard);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AtomCard.__proto__ || (0, _getPrototypeOf2.default)(AtomCard)).call.apply(_ref, [this].concat(args))), _this), _this.redirectToHref = function () {
      var href = _this.props.href;

      if (href) window.location.href = href;
    }, _this.redirectOnEnter = function (e) {
      if (e.key === 'Enter') _this.redirectToHref();
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AtomCard, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          Media = _props.media,
          Content = _props.content,
          vertical = _props.vertical,
          highlight = _props.highlight,
          href = _props.href,
          tabIndex = _props.tabIndex;

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)(BASE_CLASS, vertical && CLASS_VERTICAL, highlight && CLASS_HIGHLIGHT, href && CLASS_LINK),
          tabIndex: tabIndex,
          onClick: this.redirectToHref,
          onKeyDown: this.redirectOnEnter
        },
        _react2.default.createElement(
          'div',
          { className: CLASS_MEDIA },
          _react2.default.createElement(Media, null)
        ),
        _react2.default.createElement(
          'div',
          { className: CLASS_INFO },
          _react2.default.createElement(Content, null)
        )
      );
    }
  }]);
  return AtomCard;
}(_react.Component);

AtomCard.displayName = 'AtomCard';

AtomCard.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** HTML (component) to be displayed on the left/right side */
  media: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),

  /** HTML (component) to be displayed on the other side */
  content: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),

  /** true for vertical layout */
  vertical: _propTypes2.default.bool,

  /** true for highlight mode */
  highlight: _propTypes2.default.bool,

  /** url target of the card */
  href: _propTypes2.default.string,

  /** tab order */
  tabIndex: _propTypes2.default.string
} : {} : {};

exports.default = AtomCard;